unit tw32ex2u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WaveIn, WaveOut, StdCtrls, ExtCtrls, ComCtrls,MMSystem, Buttons,
  Tabnotbk;

type
  TMAIN = class(TForm)
    tbActivationLevel: TTrackBar;
    tbSpeakerVol: TTrackBar;
    ProgressBar1: TProgressBar;
    log: TMemo;
    btClear: TBitBtn;
    btSetFormat: TButton;
    btRecord: TSpeedButton;
    btPause: TSpeedButton;
    btPlay: TSpeedButton;
    btHelp: TBitBtn;
    btClose: TBitBtn;
    Panel1: TPanel;
    paInfo: TPanel;
    paStatus: TPanel;
    paFormat: TPanel;
    nbProperties: TTabbedNotebook;
    GroupBox1 : TGroupBox;
    GroupBox2: TGroupBox;
    wiActivationLevel: TLabel;
    wiCurLevel: TLabel;
    wiAutoActivation: TLabel;
    wiBitsPerSample: TLabel;
    wiBlockAlign: TLabel;
    wiBlockSize: TLabel;
    wibytesPerSec: TLabel;
    wiCapacity: TLabel;
    wiChannels: TLabel;
    wiDeviceID: TLabel;
    wiSamplesPerSec: TLabel;
    woBitsPerSample: TLabel;
    woBlockAlign: TLabel;
    woBytesPerSec: TLabel;
    woCapacity: TLabel;
    woChannels: TLabel;
    woDeviceID: TLabel;
    woSamplesPerSec: TLabel;
    laErrorMsg: TLabel;
    Label2: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Bevel6: TBevel;
    Label3: TLabel;
    Label4: TLabel;
    Label1: TLabel;
  {startup}
    procedure FormCreate(Sender: TObject);
    procedure initDemoComponents(Sender: TObject);

  {UI for this demo:}
    procedure btSetFormatClick(Sender: TObject);
    procedure btRecordClick(Sender: TObject);
    procedure btPlayClick(Sender: TObject);
    procedure btClearClick(Sender: TObject);
    procedure btPauseClick(Sender: TObject);
    procedure btHelpClick(Sender: TObject);

    procedure tbSpeakerVolChange(Sender: TObject);
    procedure tbActivationLevelChange(Sender: TObject);
    procedure showcurLevel(Sender: TObject);
    procedure showProperties;

 {twave component events: these procedures contain the core material of this demo}
    procedure WaveInput1WaveInput(Sender: TObject);
    procedure WaveOutput1WaveOutput(Sender: TObject);
    procedure WaveInput1Overflow(Sender: TObject);
    procedure WaveInput1Mute(Sender: TObject);
    procedure WaveOutput1End(Sender: TObject);

  private
  public
    { Public declarations }
    {create these components at runtime}
    WaveInput1: TWaveInput;
    WaveOutput1: TWaveOutput;
  end;

var
  MAIN: TMAIN;

implementation

{$R *.DFM}

procedure TMAIN.FormCreate(Sender: TObject);
begin
 {create Twave components at runtime}
 initDemoComponents(self);
 {set waveOutput properties to match input}
 waveOutput1.matchFormat(waveInput1);
{progress bar is a visual representations of the ring buffers}
 ProgressBar1.max := waveOutput1.capacity;
{displays the design/run time properties for demo:
 you will observe how selecting different wave formats
 affects the properties}
   showProperties;

 {set the volume slider position to the current system volume setting:}
   WaveOutput1.Open;
   tbSpeakerVol.Position:=100-integer(HiWord(WaveOutput1.GetVolume) div 655);
   WaveOutput1.Close;
end;

procedure TMAIN.initDemoComponents(Sender: TObject);
begin
(* waveInput1 and waveOutput1 create and initialization code
would not be required if the components were installed to the
Delphi VCL pallet.  The components are created here, in the
form create method, to make testing of these demo projects possible
without having first to install the components.*)
waveInput1 := TwaveInput.create(self);
with waveInput1 do begin
    DeviceID := -1;
    Capacity := 100;
    Asynchronous := False;
    SamplesPerSec := 11025;
    BytesPerSec := 22050;
    Channels := 1;
    BlockAlign := 2;
    BitsPerSample := 16;
    AutoActivation := True;
    ActivationLevel := 0;
    preFrame := False;
    postFrame := 0;
    BlockSize := 12500;
    OnMute := WaveInput1Mute;
    OnOverflow := WaveInput1Overflow;
    OnWaveInput := WaveInput1WaveInput;
    Left := 80;
    Top := 72;
end;
waveOutput1 := TwaveOutput.create(self);
with waveOutput1 do begin
    DeviceID := -1;
    Capacity := 100;
    SamplesPerSec := 11025;
    BytesPerSec := 22050;
    Channels := 1;
    BitsPerSample := 16;
    OnEnd := WaveOutput1End;
    OnWaveOutput := WaveOutput1WaveOutput;
    Left := 80;
    Top := 72;
end;
end;

procedure TMAIN.btSetFormatClick(Sender: TObject);
var wiError, woError : word;
    stWaveFormat : string;

begin
   if (waveInput1.state = wisOpen) or
      (waveOutput1.state = wosOpen) then
    begin
      MessageDlg('Please stop record/play before making format change', mtInformation,
       [mbOk], 0);
      exit;
     end;
   WaveOutput1.ClearRingBuffer;
   progressBar1.position := waveOutput1.messageCount;
   stWaveFormat := WaveInput1.SelectFormat;
   if (stWaveFormat = 'Cancel') or (stWaveFormat = '') then exit;

   begin
   {display the selected format}
     paFormat.caption := stWaveFormat;
   {current wave format is also always available as a string value
     by evaluating the ACMFormat property}

   {calculate appropriate block size for current wave format:}
      {WaveInput1.BlockSize:=WaveInput1.GetMinBlockSize*5;}

      waveOutput1.matchFormat(waveInput1);
   (*sets the waveOutput format to match the currently set waveInput format*)

   {not all formats displayed by ACM are directly supported by ACM wave_mapper
   services, so we still need to test if we have a valid format for the system:}
      wiError:=WaveInput1.IsFormatSupported(WaveInput1.PFWF);
      woError:=WaveOutput1.IsFormatSupported(WaveOutput1.PFWF);
      wiError:= 0;
      woError:= 0;

   {a returned value of 0 means that the format is supported}

      showProperties;
      if ((wiError <> 0) or (woError <> 0)) then
         begin
           paInfo.caption := 'format is not supported';
           btRecord.enabled := false;
           btPlay.enabled := false;
           btPause.enabled := false;
         end else
         begin
           paInfo.caption := 'format is supported';
           btRecord.enabled := true;
           btPlay.enabled := true;
           btPause.enabled := true;
         end;
   end;
end;

procedure TMAIN.showProperties;
{all of the design time properties are shown for the demo;
 see the help file for run-time only properties}
begin
{WaveInput properties}
  wiActivationLevel.caption := intToStr(waveInput1.ActivationLevel);
  wiBitsPerSample.caption := intToStr(waveInput1.bitsPerSample);
  wiBlockAlign.caption := intToStr(waveInput1.BlockAlign);
  wiBlockSize.caption := intToStr(waveInput1.BlockSize);
  wiBytesPerSec.caption := intToStr(waveInput1.BytesPerSec);
  wiCapacity.caption := intToStr(waveInput1.Capacity);
  wiChannels.caption := intToStr(waveInput1.Channels);
  wiDeviceID.caption := intToStr(waveInput1.DeviceID);
  wiSamplesPerSec.caption := intToStr(waveInput1.SamplesPerSec);
  wicurLevel.caption := intToStr(waveInput1.curLevel div 100);
  if waveInput1.autoActivation then wiautoActivation.caption := 'true' else
     wiautoActivation.caption := 'false';

{WaveOutput properties}
  woBitsPerSample.caption := intToStr(waveOutput1.bitsPerSample);
  woBlockAlign.caption := intToStr(waveOutput1.BlockAlign);
  woBytesPerSec.caption := intToStr(waveOutput1.BytesPerSec);
  woCapacity.caption := intToStr(waveOutput1.Capacity);
  woChannels.caption := intToStr(waveOutput1.Channels);
  woDeviceID.caption := intToStr(waveOutput1.DeviceID);
  woSamplesPerSec.caption := intToStr(waveOutput1.SamplesPerSec);
end;

procedure TMAIN.tbSpeakerVolChange(Sender: TObject);
var W : Word;
begin
    W:=(100-tbSpeakerVol.Position)*655;
    WaveOutput1.SetVolume(W,W);
  end;
{the reference to tbActivationLevel.max in the next to procs have to do
with the vertical orientation of the sliders in this demo UI}
procedure TMAIN.tbActivationLevelChange(Sender: TObject);
begin
   waveInput1.ActivationLevel:=(tbActivationLevel.max-tbActivationLevel.Position) * 100;
   wiActivationLevel.Caption:=IntToStr(waveInput1.ActivationLevel div 100);
end;

procedure TMAIN.showcurLevel(Sender: TObject);
begin
   tbActivationLevel.SelStart:=tbActivationLevel.max-(WaveInput1.CurLevel div 100);
   wiCurLevel.Caption:=intToStr(WaveInput1.CurLevel div 100);
end;

procedure TMAIN.btRecordClick(Sender: TObject);
{this example assumes a half-duplex audio device}
begin
   if btPause.down then btPause.down := false;
   if btRecord.Down then begin
      WaveOutput1.Stop;
      WaveOutput1.Close;
      waveInput1.Open;
      waveInput1.Start;
      paStatus.caption := 'Recording';
      {tbActivationLevel.selEnd := tbActivationLevel.max;}
   end else begin
      waveInput1.Stop;
      waveInput1.Close;
      paStatus.caption := 'Recording stopped';
      tbActivationLevel.selEnd := 0;
   end;
end;

procedure TMAIN.btPlayClick(Sender: TObject);
begin
   if btPause.down then btPause.down := false;
   if btPlay.Down then begin
      waveInput1.Stop;
      waveInput1.Close;
      if WaveOutput1.messageCount > 0 then
         begin
          WaveOutput1.Open;
          WaveOutput1.PlayBuffer;
          WaveOutput1.PlayBuffer;
          paStatus.caption := 'Playing';
         end else
         begin
           btPlay.Down := false;
           paStatus.caption := 'output buffer is empty';
         end;
   end else
   begin
      WaveOutput1.Stop;
      WaveOutput1.Close;
      paStatus.caption := 'Playing stopped';
   end;

end;

procedure TMAIN.btPauseClick(Sender: TObject);
begin
  if btPause.down then
    begin
       if btRecord.down then
          begin
          waveInput1.stop;
          tbActivationLevel.selStart:=0;
          tbActivationLevel.selEnd:=0;
          end else
          if btPlay.down then
             waveOutput1.pause else
               btPause.down := false;
    end else
    begin {pause button just clicked from down to up}
       if btRecord.down then
          begin
          tbActivationLevel.selEnd:=tbActivationLevel.max;
          waveInput1.start;
          end else
          if btPlay.down then
             waveOutput1.resume else
               btPause.down := false;
    end;
end;

procedure TMAIN.btClearClick(Sender: TObject);
begin
   log.clear;
end;

procedure TMAIN.btHelpClick(Sender: TObject);
begin
application.helpJump('');
end;

{here's your hook into managing things on a buffer level:
 this event, if defined, is called for each waveevent, as it happens
 see the help file for a definition of the waveEvent structure;
 see other Demos for examples on manipulating individual buffers.
 Here, we just want to introduce the concept of the waveEvent.}
procedure TMAIN.waveInput1WaveInput(Sender: TObject);
const  ID : LongInt=1;
var WE : TWaveEvent;
begin
   log.lines.add('waveInput');
   WE:=WaveInput1.GetWaveEvent;
   if WE=nil then exit;
   if (WE.BufData<>nil) and (WE.BufSize>0) then begin
   WaveOutput1.AddBlock(WE.Bufdata,WE.BufSize,ID);
   WE.Free;
   Inc(ID);end else WE.Free;
   ProgressBar1.Position:=WaveOutput1.MessageCount;
   showcurLevel(Self);
   if WaveOutput1.MessageCount=WaveOutput1.Capacity then begin
      btRecord.Down:=false;
      btRecordClick(Sender);
   end;
end;


(*like waveInput1WaveInput, WaveOutput is called, if defined, after each block
is played.   That is, you play a block (call waveOutput1.playbuffer), and, as
a result, your OnWaveOutput event is triggered.   As in this example, a common
action to take would be to play the next buffer; the result is an audio output
stream.   You could acheive similar results by calling playbuffer repeatedly
in a loop, as long as the messageCount was greater than 0*)
procedure TMAIN.WaveOutput1WaveOutput(Sender: TObject);
begin
   log.lines.add('output');
   {play two buffers to avoid 'gap' in some formats}
   WaveOutput1.PlayBuffer;
   WaveOutput1.PlayBuffer;
   ProgressBar1.Position:=WaveOutput1.MessageCount;
end;

(*this event is triggered, if defined, when waveInput continues
after the ringbuffer is full;  it's up to you to manage the stream
to avoid this, or to do something about it here...*)
procedure TMAIN.waveInput1Overflow(Sender: TObject);
begin
   log.lines.add('Overflow');
end;

(*this event is triggered, if defined, instead of the OnwaveInput event,
when autoActivation is TRUE, and the current input level (waveInput1.curLevel)
is below the current activation level (waveInput1.activationLevel)  *)
procedure TMAIN.waveInput1Mute(Sender: TObject);
begin
   log.lines.add('mute');
   showcurLevel(Self);
end;

(*this event is triggered, if defined, after the last waveEvent in the
waveOutput ringbuffer is played.*)
procedure TMAIN.WaveOutput1End(Sender: TObject);
begin
   waveOutput1.close;
   log.lines.add('waveout-end');
   paStatus.caption := 'All done!';
   btPlay.down := false;
end;


end.
